// RO-Aufgabe3.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>

const LEN = 5;
int vec_a [LEN] = {1,2,3,-4,2};
int *vec_a_ptr = vec_a;
int vec_b [LEN] = {-5, 4, -3, -2, -1};
int *vec_b_ptr = vec_b;
int ergebnis [LEN] = {0,0,0,0,0};
int *ergebnis_ptr = ergebnis;

int vorth (int *v_a, int *v_b, int len);
void vadd (int *v_a, int *v_b, int *res, int len);

/*
Bei beiden Funktionen gilt, dass die Vektorelemente von hinten nach vorne durchlaufen werden.
Man spart sich damit ein weiteres Register zum  Vergleichen. Um den Schleifendurchlauf zu beenden
wird mit -1 verglichen und im Gleichheitsfall kein weiterer Durchlauf zugelassen.
*/

int vorth (int *v_a, int *v_b, int len) {
	__asm{
		MOV EBX, len			// Lnge laden
		DEC EBX					// eins abziehen (lastIndex = size-1)

		MOV ECX, 0				// Register fr Zwischenergebnisse vorbereiten

		MOV ESI, v_a			// Basisadresse von v_a laden 
		MOV EDI, v_b			// Basisadresse von v_b laden

		// Schleife von n-1 => 0
	again:
		CMP EBX,-1				// Vergleich, ob schon -1
		JE endloop				// wenn ja, dann Schlu

		MOV EAX, [ESI + 4*EBX]	// Vektorelement von v_a nach EAX laden
		MOV EDX, [EDI + 4*EBX]	// Vektorelement von v_b nach EBX laden

		IMUL EDX				// Multipliziere Vektorelement vorzeichenbehaftet (EAX = EAX * EBX)
		
		ADD ECX, EAX			// Ergebnis addieren
		
		DEC EBX					// Index herunterzhlen
		JMP again				// nchstes Vektorelement bearbeiten
	endloop:
		MOV EAX, ECX			// Ergebnis nach EAX verfrachten
		CMP EAX, 0				// Vergleiche EAX auf 0
		JE end					// wenn EAX == 0, dann nichts ndern
		
		// EAX ist != 0
		MOV EAX,-1				// Rckgabewert fr: Vektoren nicht orthogonal
	end:
	}
};

void vadd (int *v_a, int *v_b, int *res, int len) {
	__asm{
		MOV EBX, len			// Lnge laden
		DEC EBX					// eins abziehen (lastIndex = size-1)

		MOV ESI, v_a			// lade Adresse des ersten Vektors in ESI
		MOV EDI, v_b			// lade Adresse des zweiten Vektors in EDI
		MOV EDX, res			// lade Adresse des Rckgabevektors in EDX

								// Schleife von n-1 => 0
	again:
		CMP EBX, -1				// teste, ob EBX = -1 (kommt vor 0)
		JE end					// wenn gleich, dann schluss

		MOV EAX, [ESI + 4*EBX]	// lade Wert in [EDX + 4*EBX]; EBX ist index, mal 4 wegen int-Gre
		ADD EAX, [EDI + 4*EBX]	// Wert des zweiten Vektors addieren
		
		MOV [EDX + 4*EBX], EAX	// zurckschreiben in Ergebnisvektor

		DEC EBX					// Index dekrementieren
		JMP again				// nochmal (nchstes Vektorelement bearbeiten)
	end:
	}
}

int _tmain(int argc, _TCHAR* argv[]) {
	printf(" vorth: %d \n", vorth(vec_a_ptr, vec_b_ptr, LEN));
	vadd(vec_a_ptr, vec_b_ptr, ergebnis_ptr, LEN);
	printf(" vadd: ");
	for (int i=0; i<LEN; i++)
		printf(" %d ", ergebnis_ptr[i]);

	while (getchar()==EOF);

return 0;
}
